%This Example for using users m-function Optimization_subroutine.m was created automatically by PSG Toolbox.

%Function description:

%maximize
%linearize = 1
%-polynom_abs(matrix_polynom_abs_q)
%Constraint: == parameter_bound
%linearmulti(matrix_yxt_lam_q)
%Constraint: == parameter_bound_1
%linear(matrix_yi)
%Constraint: == parameter_bound_2
%linear(matrix_unit)
%Box: >= point_lowerbounds, <= point_upperbounds_0p42
%Solver: parameter_solver, precision = parameter_precision
%
%Input variables:
%
%Inputs                         PSG Type    PSG Object                Location in Problem Statement                                Class
%matrix_polynom_abs_q_data      data        matrix_polynom_abs_q      -polynom_abs(matrix_polynom_abs_q)                           double
%matrix_polynom_abs_q_vars      vars        matrix_polynom_abs_q      -polynom_abs(matrix_polynom_abs_q)                           cell
%matrix_yxt_lam_q_data          data        matrix_yxt_lam_q          linearmulti(matrix_yxt_lam_q)                                double
%matrix_yxt_lam_q_vars          vars        matrix_yxt_lam_q          linearmulti(matrix_yxt_lam_q)                                cell
%matrix_yi_data                 data        matrix_yi                 linear(matrix_yi)                                            double
%matrix_yi_vars                 vars        matrix_yi                 linear(matrix_yi)                                            cell
%matrix_unit_data               data        matrix_unit               linear(matrix_unit)                                          double
%matrix_unit_vars               vars        matrix_unit               linear(matrix_unit)                                          cell
%point_lowerbounds_data         data        point_lowerbounds         Box: >= point_lowerbounds, <= point_upperbounds_0p42         double
%point_lowerbounds_vars         vars        point_lowerbounds         Box: >= point_lowerbounds, <= point_upperbounds_0p42         cell
%point_upperbounds_0p42_data    data        point_upperbounds_0p42    Box: >= point_lowerbounds, <= point_upperbounds_0p42         double
%point_upperbounds_0p42_vars    vars        point_upperbounds_0p42    Box: >= point_lowerbounds, <= point_upperbounds_0p42         cell
%parameter_bound_data           data        parameter_bound           Constraint: == parameter_bound                               double
%parameter_bound_1_data         data        parameter_bound_1         Constraint: == parameter_bound_1                             double
%parameter_bound_2_data         data        parameter_bound_2         Constraint: == parameter_bound_2                             double
%parameter_solver_data          data        parameter_solver          Solver: parameter_solver, precision = parameter_precision    char
%parameter_precision_data       data        parameter_precision       Solver: parameter_solver, precision = parameter_precision    char
%
%Output variables:
%
%solution_str = string with solution of problem;
%outargstruc_arr = array of output PSG data structures;


%Load data from mat-file:
load('D:\American Optimal Decisions\PSG\MATLAB_Stan\ready\Support Vector Machines Based on Tail Risk Measures\data_problem_4b_dual_short\Optimization_subroutine_data.mat')

%Save variables from mat-file to Workspace:
tbpsg_export_to_workspace(toolboxstruc_arr)

%Run users m-function Optimization_subroutine:

[solution_str,outargstruc_arr] = Optimization_subroutine(matrix_polynom_abs_q_data,matrix_polynom_abs_q_vars,matrix_yxt_lam_q_data,matrix_yxt_lam_q_vars,matrix_yi_data,matrix_yi_vars,matrix_unit_data,matrix_unit_vars,point_lowerbounds_data,point_lowerbounds_vars,point_upperbounds_0p42_data,point_upperbounds_0p42_vars,parameter_bound_data,parameter_bound_1_data,parameter_bound_2_data,parameter_solver_data,parameter_precision_data);

%Extract Objective:
val_obj = tbpsg_objective(solution_str, outargstruc_arr);

disp(' ');
disp('Objective = ');
disp(val_obj);

%Extract optimal solution:
point_data = tbpsg_optimal_point_data(solution_str, outargstruc_arr);

disp(' ');
disp('Optimal point = ');
disp(point_data);

%Extract structure containing PSG solution reports:
output_structure = tbpsg_solution_struct(solution_str, outargstruc_arr);

disp(' ');
disp('Structure with PSG solution = ');
disp(output_structure);

%Uncomment the following lines to extract solutions details:

%output = tbpsg_isoptimal(solution_str, outargstruc_arr);

%output = tbpsg_function_data(solution_str, outargstruc_arr);

%output = tbpsg_function_names(solution_str, outargstruc_arr);

%output = tbpsg_time(solution_str, outargstruc_arr);

%output = tbpsg_optimal_point_vars(solution_str, outargstruc_arr);

%output = tbpsg_constraints_vars(solution_str, outargstruc_arr);

%output = tbpsg_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_constraint_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_dual_data(solution_str, outargstruc_arr);

%output = tbpsg_vector_slack_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_data(solution_str, outargstruc_arr);

%output = tbpsg_matrix_vars(solution_str, outargstruc_arr);

%output = tbpsg_vector_data(solution_str, outargstruc_arr);

%=======================================================================|
%American Optimal Decisions, Inc. Copyright                             |
%Copyright American Optimal Decisions, Inc. 2007-2016.                 |
%American Optimal Decisions (AOD) retains copyrights to this material.  |
%                                                                       |
%Permission to reproduce this document and to prepare derivative works  |
%from this document for internal use is granted, provided the copyright |
%and No Warranty  statements are included with all reproductions       |
%and derivative works.                                                  |
%                                                                       |
%For information regarding external or commercial use of copyrighted    |
%materials owned by AOD, contact AOD at support@aorda.com.              |
%=======================================================================|
 
